## gimpfileops

gimpfileops — Image file operations (load, save, etc.)

## Functions

gchar * | gimp_temp_name ()
gint32 | gimp_file_load ()
gint32 | gimp_file_load_layer ()
gint * | gimp_file_load_layers ()
gboolean | gimp_file_save ()
gboolean | gimp_file_save_thumbnail ()
gboolean | gimp_register_magic_load_handler ()
gboolean | gimp_register_load_handler ()
gboolean | gimp_register_save_handler ()
gboolean | gimp_register_file_handler_priority ()
gboolean | gimp_register_file_handler_mime ()
gboolean | gimp_register_file_handler_uri ()
gboolean | gimp_register_file_handler_raw ()
gboolean | gimp_register_thumbnail_loader ()

## Description

Image file operations (load, save, etc.)

## Functions

### gimp_temp_name ()

    gchar *
    gimp_temp_name (const gchar *extension);

Generates a unique filename.

Generates a unique filename using the temp path supplied in the user's gimprc.

#### Parameters

extension | The extension the file will have. |

#### Returns

The new temp filename.

### gimp_file_load ()

    gint32
    gimp_file_load (GimpRunMode run_mode,
                    const gchar *filename,
                    const gchar *raw_filename);

Loads an image file by invoking the right load handler.

This procedure invokes the correct file load handler using magic if possible, and falling back on the file's extension and/or prefix if not. The name of the file to load is typically a full pathname, and the name entered is what the user actually typed before prepending a directory path. The reason for this is that if the user types https://www.gimp.org/foo.png he wants to fetch a URL, and the full pathname will not look like a URL.

#### Parameters

run_mode | The run mode. |
filename | The name of the file to load. |
raw_filename | The name as entered by the user. |

#### Returns

The output image.

### gimp_file_load_layer ()

    gint32
    gimp_file_load_layer (GimpRunMode run_mode,
                          gint32 image_ID,
                          const gchar *filename);

Loads an image file as a layer for an existing image.

This procedure behaves like the file-load procedure but opens the specified image as a layer for an existing image. The returned layer needs to be added to the existing image with `gimp_image_insert_layer()`.

#### Parameters

run_mode | The run mode. |
image_ID | Destination image. |
filename | The name of the file to load. |

#### Returns

The layer created when loading the image file.

Since: 2.4

### gimp_file_load_layers ()

    gint *
    gimp_file_load_layers (GimpRunMode run_mode,
                           gint32 image_ID,
                           const gchar *filename,
                           gint *num_layers);

Loads an image file as layers for an existing image.

This procedure behaves like the file-load procedure but opens the specified image as layers for an existing image. The returned layers needs to be added to the existing image with `gimp_image_insert_layer()`.

#### Parameters

run_mode | The run mode. |
image_ID | Destination image. |
filename | The name of the file to load. |
num_layers | The number of loaded layers. |

#### Returns

The list of loaded layers.

Since: 2.4

### gimp_file_save ()

    gboolean
    gimp_file_save (GimpRunMode run_mode,
                    gint32 image_ID,
                    gint32 drawable_ID,
                    const gchar *filename,
                    const gchar *raw_filename);

Saves a file by extension.

This procedure invokes the correct file save handler according to the file's extension and/or prefix. The name of the file to save is typically a full pathname, and the name entered is what the user actually typed before prepending a directory path. The reason for this is that if the user types https://www.gimp.org/foo.png she wants to fetch a URL, and the full pathname will not look like a URL.

#### Parameters

run_mode | The run mode. |
image_ID | Input image. |
drawable_ID | Drawable to save. |
filename | The name of the file to save the image in. |
raw_filename | The name as entered by the user. |

#### Returns

TRUE on success.

### gimp_file_save_thumbnail ()

    gboolean
    gimp_file_save_thumbnail (gint32 image_ID,
                              const gchar *filename);

Saves a thumbnail for the given image

This procedure saves a thumbnail for the given image according to the Free Desktop Thumbnail Managing Standard. The thumbnail is saved so that it belongs to the file with the given filename. This means you have to save the image under this name first, otherwise this procedure will fail. This procedure may become useful if you want to explicitly save a thumbnail with a file.

#### Parameters

image_ID | The image. |
filename | The name of the file the thumbnail belongs to. |

#### Returns

TRUE on success.

### gimp_register_magic_load_handler ()

    gboolean
    gimp_register_magic_load_handler (const gchar *procedure_name,
                                      const gchar *extensions,
                                      const gchar *prefixes,
                                      const gchar *magics);

Registers a file load handler procedure.

Registers a procedural database procedure to be called to load files of a particular file format using magic file information.

#### Parameters

procedure_name | The name of the procedure to be used for loading. |
extensions | comma separated list of extensions this handler can load (i.e. \"jpg,jpeg\"). |
prefixes | comma separated list of prefixes this handler can load (i.e. \"http:,ftp:\"). |
magics | comma separated list of magic file information this handler can load (i.e. \"0,string,GIF\"). |

#### Returns

TRUE on success.

### gimp_register_load_handler ()

    gboolean
    gimp_register_load_handler (const gchar *procedure_name,
                                const gchar *extensions,
                                const gchar *prefixes);

Registers a file load handler procedure.

Registers a procedural database procedure to be called to load files of a particular file format.

#### Parameters

procedure_name | The name of the procedure to be used for loading. |
extensions | comma separated list of extensions this handler can load (i.e. \"jpg,jpeg\"). |
prefixes | comma separated list of prefixes this handler can load (i.e. \"http:,ftp:\"). |

#### Returns

TRUE on success.

### gimp_register_save_handler ()

    gboolean
    gimp_register_save_handler (const gchar *procedure_name,
                                const gchar *extensions,
                                const gchar *prefixes);

Registers a file save handler procedure.

Registers a procedural database procedure to be called to save files in a particular file format.

#### Parameters

procedure_name | The name of the procedure to be used for saving. |
extensions | comma separated list of extensions this handler can save (i.e. \"jpg,jpeg\"). |
prefixes | comma separated list of prefixes this handler can save (i.e. \"http:,ftp:\"). |

#### Returns

TRUE on success.

### gimp_register_file_handler_priority ()

    gboolean
    gimp_register_file_handler_priority (const gchar *procedure_name,
                                         gint priority);

Sets the priority of a file handler procedure.

Sets the priority of a file handler procedure. When more than one procedure matches a given file, the procedure with the lowest priority is used; if more than one procedure has the lowest priority, it is unspecified which one of them is used. The default priority for file handler procedures is 0.

#### Parameters

procedure_name | The name of the procedure to set the priority of. |
priority | The procedure priority. |

#### Returns

TRUE on success.

Since: 2.10.6

### gimp_register_file_handler_mime ()

    gboolean
    gimp_register_file_handler_mime (const gchar *procedure_name,
                                     const gchar *mime_types);

Associates MIME types with a file handler procedure.

Registers MIME types for a file handler procedure. This allows GIMP to determine the MIME type of the file opened or saved using this procedure. It is recommended that only one MIME type is registered per file procedure; when registering more than one MIME type, GIMP will associate the first one with files opened or saved with this procedure.

#### Parameters

procedure_name | The name of the procedure to associate a MIME type with. |
mime_types | A comma-separated list of MIME types, such as \"image/jpeg\". |

#### Returns

TRUE on success.

Since: 2.2

### gimp_register_file_handler_uri ()

    gboolean
    gimp_register_file_handler_uri (const gchar *procedure_name);

Registers a file handler procedure as capable of handling URIs.

Registers a file handler procedure as capable of handling URIs. This allows GIMP to call the procedure directly for all kinds of URIs, and the 'filename' traditionally passed to file procedures turns into an URI.

#### Parameters

procedure_name | The name of the procedure to enable URIs for. |

#### Returns

TRUE on success.

Since: 2.10

### gimp_register_file_handler_raw ()

    gboolean
    gimp_register_file_handler_raw (const gchar *procedure_name);

Registers a file handler procedure as capable of handling raw camera files.

Registers a file handler procedure as capable of handling raw digital camera files. Use this procedure only to register raw load handlers, calling it on a save handler will generate an error.

#### Parameters

procedure_name | The name of the procedure to enable raw handling for. |

#### Returns

TRUE on success.

Since: 2.10

### gimp_register_thumbnail_loader ()

    gboolean
    gimp_register_thumbnail_loader (const gchar *load_proc,
                                    const gchar *thumb_proc);

Associates a thumbnail loader with a file load procedure.

Some file formats allow for embedded thumbnails, other file formats contain a scalable image or provide the image data in different resolutions. A file plug-in for such a format may register a special procedure that allows GIMP to load a thumbnail preview of the image. This procedure is then associated with the standard load procedure using this function.

#### Parameters

load_proc | The name of the procedure the thumbnail loader with. |
thumb_proc | The name of the thumbnail load procedure. |

#### Returns

TRUE on success.

Since: 2.2